"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
// import { ServerCapabilities } from 'vscode-languageserver-protocol';
const lsp_editor_adapter_1 = require("lsp-editor-adapter");
class LSPConnection extends lsp_editor_adapter_1.LspWsConnection {
    constructor(options) {
        super(options);
    }
    sendSelectiveChange(changeEvent) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this._sendChange([changeEvent]);
        });
    }
    sendFullTextChange(text) {
        this._sendChange([{ text }]);
    }
    _sendChange(changeEvents) {
        // @ts-ignore
        if (!this.isConnected) {
            return;
        }
        // @ts-ignore
        let documentInfo = this.documentInfo;
        const textDocumentChange = {
            textDocument: {
                uri: documentInfo.documentUri,
                // @ts-ignore
                version: this.documentVersion
            },
            contentChanges: changeEvents
        };
        // @ts-ignore
        this.connection.sendNotification('textDocument/didChange', textDocumentChange);
        // @ts-ignore
        this.documentVersion++;
    }
}
exports.LSPConnection = LSPConnection;
