import { IMagicOverride } from './overrides';
declare abstract class MagicsMap extends Map<RegExp, string> {
    constructor(magic_overrides: IMagicOverride[]);
    abstract override_for(code: string): string | null;
    protected _override_for(code: string): string | null;
}
export declare class CellMagicsMap extends MagicsMap {
    override_for(cell: string): string | null;
}
export declare class LineMagicsMap extends MagicsMap {
    override_for(line: string): string | null;
    replace_all(raw_lines: string[]): {
        lines: string[];
        skip_inspect: boolean[];
    };
}
export {};
