/// <reference types="@types/codemirror" />
import { VirtualEditor } from '../editor';
import { CodeMirror } from '../../adapters/codemirror';
import { IEditorPosition, IRootPosition } from '../../positioning';
export declare class VirtualFileEditor extends VirtualEditor {
    protected cm_editor: CodeMirror.Editor;
    constructor(language: string, path: string, cm_editor: CodeMirror.Editor);
    transform_virtual_to_source(position: CodeMirror.Position): CodeMirror.Position;
    transform_editor_to_root(cm_editor: CodeMirror.Editor, position: IEditorPosition): IRootPosition;
    get_editor_index(position: CodeMirror.Position): number;
    get_cm_editor(position: IRootPosition): CodeMirror.Editor;
    protected perform_documents_update(): void;
    addEventListener(type: string, listener: EventListenerOrEventListenerObject): void;
}
